from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.iptrunk \
    import IptrunkBlock, IptrunkBlockInactive, IptrunkBlockProvisioning


class IptrunkInactive(SubscriptionModel, is_base=True):
    iptrunk: IptrunkBlockInactive


class IptrunkProvisioning(IptrunkInactive,
                         lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    iptrunk: IptrunkBlockProvisioning


class Iptrunk(IptrunkProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    iptrunk: IptrunkBlock
